require 'securerandom'
require 'json'

class KafkaSession
  class Message
    attr_reader :value, :session_id, :published_at

    def self.parse(json_message_value)
      parsed = JSON.parse(json_message_value)

      new(
        parsed["value"],
        session_id:   parsed["session_id"],
        published_at: parsed["published_at"]
      )
    end

    def initialize(value, session_id:, published_at: KafkaSession.now)
      @value        = value
      @session_id   = session_id
      @published_at = published_at
    end

    def to_json
      {
        value:        value,
        session_id:   session_id,
        published_at: published_at.to_i
      }.to_json
    end
  end
end
